"""
This is the tool for handling the keywords

$Id: SmartCsvExporterTool.py 2 2008-07-07 14:14:32Z gael.le-mignot $
"""

from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem
from AccessControl import ClassSecurityInfo
from OFS.PropertyManager import PropertyManager

import csv, time
from cStringIO import StringIO

from Products.CMFCore.utils import UniqueObject, getToolByName

ID = 'portal_smart_csv_exporter'
TITLE = 'Smart CSV Exporter'
META_TYPE = 'SmartCsvExporterTool'


class SmartCsvExporterTool(UniqueObject, SimpleItem, PropertyManager):
    """
    This is the tool for handling the keywords
    """
    id = ID
    title = TITLE
    meta_type = META_TYPE

    ## Define properties
    _properties = ()

    manage_options = (PropertyManager.manage_options
                      + SimpleItem.manage_options)

    ## Security shortcuts
    security = ClassSecurityInfo()

    security.declarePrivate("export_csv")
    def export_csv(self, name, data):
        """
        Do a CSV export from a Python list
        """
        buffer = StringIO()
        writer = csv.writer(buffer, quoting = csv.QUOTE_ALL)
        for row in data:
            writer.writerow(row)
        value = buffer.getvalue()
        value = unicode(value, "utf-8").encode("iso-8859-1", "replace")
        self.REQUEST.RESPONSE.setHeader('Content-Type', 'text/csv')
        self.REQUEST.RESPONSE.setHeader('Content-Disposition', 'attachment;filename=%s-%s.csv' % (name, time.strftime("%Y%m%d-%H%M")))
        return value

    security.declareProtected("Manage portal", "export_as_csv")
    def export_as_csv(self):
        """
        Modify keywords of object
        """
        parent = self.aq_parent
        fields = parent.getCustomViewFields()

        vocab = parent.listMetaDataFields(False)
        data = [ [ vocab.getValue(field, field) for field in fields ] ]
        
        items = parent.queryCatalog()
        for item in items:
            line = [ getattr(item, field, "") for field in fields ]
            data.append(line)

        return self.export_csv(parent.getId(), data)
        

InitializeClass(SmartCsvExporterTool)
